/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _errcnv.c,v 1.2 1993/08/16 13:34:10 mura Exp $
 */

/* System headers */
#include <errno.h>
#include <sys/dos.h>
#include <sys/xglob.h>

/* File scope variables */
static int _doserr_conv[_DOSE_MAX + 1] = {
    0,			/*   0 G[ł͂Ȃ -> 0 */
    ENOENT,		/*  -1 ȃt@NV -> ENOENT */
    ENOENT,		/*  -2 t@Ct܂ -> ENOENT */
    ENOENT,		/*  -3 fBNgt܂ -> ENOENT */
    EMFILE,		/*  -4 I[vt@C -> EMFILE */
    EISDIR,		/*  -5 fBNgɂł -> EISDIR */
    EBADF,		/*  -6 nh͖ -> EBADF */
    EFAULT,		/*  -7 Ǘ̈j -> ENOMEM */
    ENOMEM,		/*  -8 sɃȂ -> ENOMEM */
    EFAULT,		/*  -9 sȃǗ|C^ -> EFAULT */
    EFAULT,		/* -10 sȊ -> EFAULT */
    ENOEXEC,		/* -11 stH[}bgG[ -> ENOEXEC */
    EINVAL,		/* -12 sȈ -> EINVAL */
    ENOENT,		/* -13 sȃt@C -> ENOENT */
    EINVAL,		/* -14 sȃp[^ -> EINVAL */
    EXDEV,		/* -15 sȃhCu -> EXDEV */
    ENOTEMPTY,		/* -16 Jg͍폜łȂ -> ENOTEMPTY */
    EPERM,		/* -17 ioctlłȂfoCX -> EPERM */
    ENOENT,		/* -18 ȏ㌩tȂ -> ENOENT */
    EACCES,		/* -19 ݂łȂt@C -> EACCES */
    EEXIST,		/* -20 łɓo^ꂽfBNg -> EEXIST */
    ENOTEMPTY,		/* -21 fBNgłȂ -> ENOTEMPTY */
    EPERM,		/* -22 l[łȂ -> EPERM */
    ENOSPC,		/* -23 fBXNt -> ENOSPC */
    ENOSPC,		/* -24 fBNgt -> ENOSPC */
    ESPIPE,		/* -25 V[NłȂ -> ESPIPE */
    EPERM,		/* -26 d supervisor -> EPERM */
    ENOSYS,		/* -27 ` ..... -> ENOSYS */
    ETXTBSY,		/* -28 ̃Xbh݂ -> ETXTBSY */
    EIO,		/* -29 bZ[W󂯎܂ł -> EIO */
    ESRCH,		/* -30 Xbhԍُł -> ESRCH */
    ENOSYS,		/* -31 ` ..... -> ENOSYS */
    ENFILE,		/* -32 VFAOt@CI[o[ -> ENFILE */
    ENOLCK,		/* -33 bNᔽ -> ENOLCK */
    ENOSYS,		/* -34 ` ..... -> ENOSYS */
    ELOOP,		/* -35 V{bNN[v -> ELOOP (g) */
    EEXIST,		/* -36 t@Cłɑ݂ -> EEXIST (g) */
    ERANGE,		/* -37 obt@I[o[ -> ERANGE (g) */
    ENOSYS,		/* -38 T|[gĂȂ -> ENOSYS (g) */
    EEXIST,		/* -39 łɑ݂? -> EEXIST */
};

/* Functions */
int _errcnv (int dos_error)
{
    /* ΉG[ԍɕϊ */
    return (dos_error > 0 || dos_error < -_DOSE_MAX)
	? 0 : _doserr_conv[-dos_error];
}
