/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _sigend.c,v 1.1.1.1 1993/04/18 16:20:46 mura Exp $
 */

/* System headers */
#include <interrupt.h>
#include <sys/dos.h>
#include <sys/xsignal.h>

/* Functions */
void _sigend (void)
{
    int ssp, level;
    efunc_t *vector;

    /* Supervisor [h */
    ssp = _dos_super (0);

    /* 荞ׂ݂ă}XN */
    level = intlevel (7);

    /* Alarm clock Ƃɖ߂ */
    _sigrtcsave (-1);

    /* Alarm 荞݃GbWƂɖ߂ */
    MFP->aer.alarm = _oldmfp.aer;

    /* Alarm 荞݃Cl[uƂɖ߂ */
    MFP->ierb.alarm = _oldmfp.ierb;

    /* Alarm 荞݃}XNƂɖ߂ */
    MFP->imrb.alarm = _oldmfp.imrb;

    /* 荞ݏAhXƂɖ߂ */
    vector = (efunc_t *) ((MFP->vr & 0xf0) * sizeof (efunc_t));
    *vector = _oldrtc;

    /* XvAX荞݂߂ */
    if ((int) _oldspr > 0)
	_dos_intvcs (SPURIO_VECTORNO, (void *) _oldspr);

    /* kill_pr xN^̃tbN߂ */
    if ((int) _oldkpr > 0)
	_dos_intvcs (KILLPR_VECTORNO, (void *) _oldkpr);

    /* trap14xN^[ɖ߂ */
    if ((int) _olderr > 0)
	_dos_intvcs (TRAP14_VECTORNO, (void *) _olderr);

    /* _dos_ctlabort xN^[ɖ߂ */
    if ((int) _oldctl > 0)
	_dos_intvcs (CTLABT_VECTORNO, (void *) _oldctl);

    /* _dos_errabort xN^[ɖ߂ */
    if ((int) _oldabt > 0)
	_dos_intvcs (ERRABT_VECTORNO, (void *) _oldabt);

    /* _iocs_abortjob xN^[ݒ肷 */
    if ((int) _oldabj > 0)
	_dos_intvcs (ABRTJB_VECTORNO, (void *) _oldabj);

    /* _dos_exit2 xN^[ݒ肷 */
    if ((int) _oldex2 > 0)
	_dos_intvcs (DEXIT2_VECTORNO, (void *) _oldex2);

    /* dos ̃u[N`FbNɖ߂ */
    _dos_breakck (_oldbrk);

    /* 荞݃}XNxƂɖ߂ */
    intlevel (level);

    /* Usermdoe  */
    if (ssp > 0)
	_dos_super (ssp);
}
