/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _siginit.c,v 1.3 1993/06/22 07:13:49 mura Exp $
 */

/* System headers */
#include <interrupt.h>
#include <sys/dos.h>
#include <sys/xsignal.h>
#include <sys/xstart.h>

/* Externel variables */
efunc_t _oldabj;
efunc_t _oldabt;
efunc_t _oldctl;
efunc_t _olderr;
efunc_t _oldex2;
efunc_t _oldkpr;
efunc_t _oldspr;
efunc_t _oldrtc;

/* Externel variables */
int _oldbrk;
mfpsave_t _oldmfp;

/* Functions */
void _siginit (void)
{
    int ssp, level;
    efunc_t *vector;

    /* dos ̃u[N`FbNۑ */
    _oldbrk = _dos_breakck (-1);

    /* dos ̃u[N`FbNSĂɂ */
    _dos_breakck (1);

    /* _dos_exit2 xN^[ݒ肷 */
    _oldex2 = _dos_intvcs (DEXIT2_VECTORNO, (void *) _exit);

    /* _iocs_abortjob xN^[ݒ肷 */
    _oldabj = _dos_intvcs (ABRTJB_VECTORNO, (void *) _intabt);

    /* _dos_errabort xN^[ݒ肷 */
    _oldabt = _dos_intvcs (ERRABT_VECTORNO, (void *) _intabt);

    /* _dos_ctlabort xN^[ݒ肷 */
    _oldctl = _dos_intvcs (CTLABT_VECTORNO, (void *) _intctl);

    /* trap14xN^[ݒ肷 */
    _olderr = _dos_intvcs (TRAP14_VECTORNO, (void *) _interr);

    /* _dos_kill_pr xN^̃tbNݒ肷 */
    _oldkpr = _dos_intvcs (KILLPR_VECTORNO, (void *) _intabt);

    /* XvAX荞݂𖳌 */
    _oldspr = _dos_intvcs (SPURIO_VECTORNO, (void *) _intrte);

    /* Supervisor [h */
    ssp = _dos_super (0);

    /* 荞ׂ݂ă}XN */
    level = intlevel (7);

    /* Alarm clock ۑ */
    _sigrtcsave (0);

    /* MFP CH0 (GPIP0) 荞ݏAhXݒ */
    vector = (efunc_t *) ((MFP->vr & 0xf0) * sizeof (efunc_t));
    _oldrtc = *vector;
    *vector = (efunc_t) _intrtc;

    /* Alarm 荞݃GbW𗧂オɐݒ */
    _oldmfp.aer = MFP->aer.alarm;
    MFP->aer.alarm = 0;

    /* Alarm 荞݃}XN OFF */
    _oldmfp.imrb = MFP->imrb.alarm;
    MFP->imrb.alarm = 1;

    /* Alarm 荞݃Cl[u ON */
    _oldmfp.ierb = MFP->ierb.alarm;
    MFP->ierb.alarm = 1;

    /* 荞݃}XNxƂɖ߂ */
    intlevel (level);

    /* Usermode  */
    if (ssp > 0)
	_dos_super (ssp);
}
