/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: strtoul.c,v 1.3 1993/11/13 06:35:12 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>
#include <limits.h>

/* Functions */
unsigned long strtoul (const char *str, char **end, int base)
{
    int c;
    int sign, over;
    unsigned long val;
    const char *top, *save;

    /* base `FbN */
    if ((base != 0 && base < 2) || base > 36) {
	errno = EINVAL;
	return 0;
    }

    /* top ۑ */
    top = str;

    /* 擪̋󔒂΂ */
    while (isspace (*str))
	str++;

    /* ʏ͐ */
    sign = 0;

    /*  */
    switch (*str) {
    case '-':
	sign = 1;
    case '+':
	str++;
	break;
    }

    /* base  */
    if (base == 0) {

	/* 擪 0 ? */
	if (*str == '0') {

	    /* ̕ x,X Ȃ 16 i */
	    if (str[1] == 'x' || str[1] == 'X') {
		base = 16;
		str += 2;
	    }

	    /* ႤȂ 8 i */
	    else
		base = 8;

	}

	/* ႤȂ 10 i */
	else
	    base = 10;

    }

    /* 肸݂ 16 iȂ 0x ΂ */
    else if (base == 16) {
	if (*str == '0' && (str[1] == 'X' || str[1] == 'x'))
	    str += 2;
    }

    /* lϊJn̑OɂƏ */
    val = 0;
    over = 0;
    save = str;

    /* lϊ */
    while (c = *str) {

	/* 0-9,a-z,A-Z  */
	if (isdigit (c))
	    c -= '0';
	else if (islower (c))
	    c -= 'a' - 10;
	else if (isupper (c))
	    c -= 'A' - 10;
	else
	    break;

	/* base `FbN */
	if (c >= base)
	    break;

	/* I[o[t[`FbN */
	if (over == 0) {

	    /* l`FbN */
	    if (val > (ULONG_MAX - (unsigned) c) / (unsigned) base) {
		val = (signed) ULONG_MAX;
		errno = ERANGE;
		over = 1;
	    }

	    /* XV */
	    else {
		val *= base;
		val += c;
	    }

	}

	/* is */
	str++;

    }

    /* |C^ݒ (萔Ȃꍇ͐擪̃AhXԂ) */
    if (end)
	*end = (char *) ((str == save) ? top : str);

    /* I */
    return sign ? ULONG_MAX - val + 1 : val;
}
