/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: d_import.c,v 1.3 1993/10/06 17:05:55 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <string.h>
#include <sys/dos.h>
#include <sys/xdoseml.h>
#include <sys/xstart.h>

/* Structures and unions */
struct _memimg {
    struct _mep mep;
    struct _psp psp;
    char prog[0];
};

/* Macros */
#define _GETMP(psp)   ((char *) (psp) - sizeof (struct _mep))
#define _ISKEEPMEM(x) (((int) (x) & 0xff000000) == 0xff000000)

/* File scope functions */
void *_keeppr_search (const struct _psp *psp, const char *str, char offset)
{
    void *addr;
    struct _memimg *ps;

    /* addr  */
    addr = 0;

    /* ̃Ǘ|C^߂ */
    ps = (struct _memimg *) _GETMP (psp);

    /* Ǘ|C^ǂ */
    while (ps = ps->mep.prev_mp) {

	/* 풓vO TEXT  offset ʒu̕𒲂ׂ */
	if (_ISKEEPMEM (ps->mep.parent_mp)) {
	    if (strncmp (ps->prog + offset, str, strlen (str)) == 0) {
		addr = ps->prog;
		break;
	    }
	}

    }

    /* addr Ԃ */
    return addr;
}

/* Functions */
int *_dos_importlnenv (void)
{
    int ssp;
    static int _chkflg = 0;
    static int *_lnenv;

    /* 풓`FbNςׂ݂ */
    if (_chkflg == 0) {

	/* `FbNς */
	_chkflg = 1;

	/* X[p[oCU[[hֈڍs */
	ssp = _dos_super (0);

	/* lndrv  */
	_lnenv = _keeppr_search (_procp, "LNDR", 0);

	/* `FbN */
	if (_lnenv == 0 || _lnenv[LNDRV_VERSION] == 'V   ' ||
	    _lnenv[LNDRV_VERSION] == 'V030' || _lnenv[LNDRV_VERSION] == 'V100')
	    _lnenv = 0;

	/* [U[[hֈڍs */
	if (ssp > 0)
	    _dos_super (ssp);

    }

    /* ̊Ԃ */
    return _lnenv;
}
