/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: getclock.c,v 1.1 1993/11/13 06:36:49 mura Exp $
 */

/* System headers */
#include <sys/timers.h>
#include <sys/iocs.h>
#include <time.h>
#include <errno.h>

/* Functions */
int getclock (int clock_type, struct timespec *tp)
{
    int clock;

    /* `FbN */
    if (tp == 0) {
	errno = EINVAL;
	return -1;
    }

    /* 1/100 PʃNbN𓾂 */
    clock = _iocs_ontime ();

    /* NbN^Cvɂ蕪 */
    switch (clock_type) {

    case TIMEOFDAY:			/*  */
	tp->tv_sec  = (time (0));
	tp->tv_nsec = (clock % 100) * 10000000;
	break;

    case UPTIME:			/* N̎ */
	tp->tv_sec  = (clock / 100);
	tp->tv_nsec = (clock % 100) * 10000000;
	break;

    default:				/* ȊO */
	errno = EINVAL;
	return -1;

    }

    /* I */
    return 0;
}
